/***************************************************************************
                          clientworld.h  -  description
                             -------------------
    begin                : Wed Oct 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef CLIENTWORLD_H
#define CLIENTWORLD_H

#include "world.h"

/**
  *@author Flemming Frandsen
  */

#include "netpackets.h"
#include "serializer_writer.h"

class Soundsystem;

class Clientworld : public World  {
public: 
	Clientworld(Loader *loader_, Soundsystem *soundsystem_, int ownerid_);
	Clientworld();
	~Clientworld();

	void init(Loader *loader_, Soundsystem *soundsystem_, int ownerid_);

	Serializer_writer serializer_writer;

	/*
	 * Called by the client to parse the thoughts stored in the thoughts
	 * make sure to set the thoughts before calling clientthink()!
	 */
	void client_think();

	virtual bool isclient() {return true;}

	/* creates an anonymous object (one without id, that only exists on the client)
   * these objects are NOT allowed to interact with real objects and they cannot change the map
	 */
	Obj_base *newanonobject(Object_type objecttype);

	//renders the world (map and objects) into the viewport
	void draw(Viewport *viewport);

	//0=no gore, 5=normal, 10=insane
	int gorelevel;

	//puts a hole to the map and spawns a couple of debris particles
	virtual void makehole(int x, int y, int diameter);

	int getowner() {return ownerid;}

	bool createmap(Net_joinreply &joinreply, char *map_data);

	int get_anon_objects_inuse() {return anon_objects_inuse;}

	protected:

	//owner of this world.
	int ownerid;

	Obj_base *anon_objects[MAX_ANON_OBJECTS];
	int anon_objects_inuse;
};

#endif
