/***************************************************************************
                          event.cpp  -  description
                             -------------------
    begin                : Mon Feb 21 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "event.h"
#include "event_target.h"

//-----------------------------------------------------------------------------
bool Event_keyboard_key::happen(Event_target *target)
{
	return target->handle_keyboard_key(this);
}

//-----------------------------------------------------------------------------
bool Event_keyboard_key::key_pressed()
{
	return keyboard_key->type == SDL_KEYDOWN;
}

//-----------------------------------------------------------------------------
bool Event_mouse_key::happen(Event_target *target)
{
	return target->handle_mouse_key(this);
}

//-----------------------------------------------------------------------------
bool Event_mouse_key::key_pressed()
{
	return mouse_key->type == SDL_MOUSEBUTTONDOWN;
}

//-----------------------------------------------------------------------------
bool Event_mouse_motion::happen(Event_target *target)
{
	return target->handle_mouse_motion(this);
}

//-----------------------------------------------------------------------------
Event *new_event(SDL_Event *event)
{
	switch (event->type) {
  	case SDL_KEYDOWN:
		case SDL_KEYUP:
    	return new Event_keyboard_key(&event->key);

		case SDL_MOUSEMOTION:
			return new Event_mouse_motion(&event->motion);

		case SDL_MOUSEBUTTONDOWN:
		case SDL_MOUSEBUTTONUP:
			return new Event_mouse_key(&event->button);

		default : return NULL;
	}	
}
