/***************************************************************************
                          event.h  -  description
                             -------------------
    begin                : Mon Feb 21 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#ifndef EVENT_H
#define EVENT_H

#include <SDL/SDL.h>

//-----------------------------------------------------------------------------
class Event_target;
class Event {
public: 
	virtual bool happen(Event_target *target)=0;
};

//Creates an Event object from an SDL event;
Event *new_event(SDL_Event *event);

//-----------------------------------------------------------------------------
class Event_keyboard_key : public Event {
public:
	Event_keyboard_key(SDL_KeyboardEvent *keyboard_key_) {keyboard_key = keyboard_key;}	

	virtual bool happen(Event_target *target);

	SDL_KeyboardEvent *keyboard_key;
	bool key_pressed();
};

//-----------------------------------------------------------------------------
class Event_mouse_motion : public Event {
public:
	Event_mouse_motion(SDL_MouseMotionEvent *mouse_motion_) {mouse_motion = mouse_motion_;}

	virtual bool happen(Event_target *target);

	SDL_MouseMotionEvent *mouse_motion;
};

//-----------------------------------------------------------------------------
class Event_mouse_key : public Event {
public:
	Event_mouse_key(SDL_MouseButtonEvent *mouse_key_) {mouse_key = mouse_key_;}

	virtual bool happen(Event_target *target);

	SDL_MouseButtonEvent *mouse_key;
	bool key_pressed();
};

#endif
