/***************************************************************************
                          graphics.h  -  description
                             -------------------
    begin                : Sun Oct 17 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#ifndef GRAPHICS_H
#define GRAPHICS_H

/**Class for loading and storing sprites
  *@author Flemming Frandsen
  */

#include "graphic.h"

class Graphic;
class Loaded_graphics;
class Loader;
class Graphics {
public: 
	Graphics();
	~Graphics();

	void init(Loader *loader_);

	/*returns the pointer to the named graphic
	 *the name is just the relative filename also used when talking to the loader
	 *---something is used for internal names?
	 *this will load the graphic from file if it hasn't been loaded before
	 *or simply return the pointer to the previously loaded one.
	 *the users (read Obj_sometings) should store the Graphic * to keep the use of this
	 *function down to a minimum.
	 */
	Graphic *getgraphic(char *name);

	//adds a graphic to the collection
	Graphic *new_graphic(char *name);
	void delete_graphic(char *name);


protected:
	Loader *loader;
	Loaded_graphics *graphics;
};

#endif