/***************************************************************************
                          keyboard.h  -  description
                             -------------------
    begin                : Thu Oct 28 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef KEYBOARD_H
#define KEYBOARD_H

#include "systemheaders.h"

/**
  *@author Flemming Frandsen
  */
typedef struct Keyboardkey {
	int sym;
	char ascii;
};

#define MAX_KEYS 200

class Keyboard {
public: 
	Keyboard(Display *display_);
	~Keyboard();

	void clear(); //clears the buffer
	Keyboardkey getkey(); //gets the next key in the buffer and removes it.

	bool ispressed(int keysym);		//tests to see if a certain key has been pressed
	char *getkeyname(Keyboardkey ke);	//converts the keycode to a human readable name, used for configuration

	void poll();

protected:
	//This buffer is used when returning the name of a key from getkeyname()
	char keynamebuffer[200];

	Keyboardkey buffer[MAX_KEYS];
	int buffer_inuse;

	int keysdown[MAX_KEYS];
	int keysdown_inuse;
		
	Display *display;
};

#endif

