/***************************************************************************
                          keymapper.cpp  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "keymapper.h"
#include "keymapper_bindings.h"

//----------------------------------------------------------------------------

Keymapper::Keymapper()
{
	bindings = new Keymapper_bindings;

	//general purpose keys:
	bindings->addbinding(SDLK_F2,  KEYFUNCTION::SCREEN_SHOOT,    "key_Screen_shoot", 	  "Save screen shot");
	bindings->addbinding(SDLK_F3,  KEYFUNCTION::TOGGLE_LOGO,     "key_Toggle_logo",     "Logo (on/off)");
	bindings->addbinding(SDLK_F4,  KEYFUNCTION::TOGGLE_DEATHCAM, "key_Toggle_deathcam", "Deathcam (on/off)");
	bindings->addbinding(SDLK_F5,  KEYFUNCTION::TOGGLE_TRAFFIC,  "key_Toggle_traffic",  "Traffic graph (on/off)");
	bindings->addbinding(SDLK_F6,  KEYFUNCTION::TOGGLE_FRAMERATE,"key_Toggle_framerate","Framerate (on/off)");
	bindings->addbinding(SDLK_F7,  KEYFUNCTION::TOGGLE_SHADOW,   "key_Toggle_shadow",   "Drop shadow (on/off)");
	bindings->addbinding(SDLK_F8,  KEYFUNCTION::TOGGLE_SMOOTH,   "key_Toggle_smooth",   "Bilinear smoothing (on/off)");
	bindings->addbinding(SDLK_ESCAPE,KEYFUNCTION::MENU,"key_Menu","Bring up the menu");

	//player 1 keys:
	bindings->addbinding(SDLK_UP,    KEYFUNCTION::PLAYER1 | KEYFUNCTION::UP       ,"key_Player1_up",        "p1 Up");
	bindings->addbinding(SDLK_DOWN,  KEYFUNCTION::PLAYER1 | KEYFUNCTION::DOWN     ,"key_Player1_down",      "p1 Down");
	bindings->addbinding(SDLK_LEFT,  KEYFUNCTION::PLAYER1 | KEYFUNCTION::LEFT     ,"key_Player1_left",      "p1 Left");
	bindings->addbinding(SDLK_RIGHT, KEYFUNCTION::PLAYER1 | KEYFUNCTION::RIGHT    ,"key_Player1_right",     "p1 Right");
	bindings->addbinding(SDLK_LCTRL, KEYFUNCTION::PLAYER1 | KEYFUNCTION::FIRE     ,"key_Player1_fire",      "p1 Fire");
	bindings->addbinding(SDLK_LSHIFT,KEYFUNCTION::PLAYER1 | KEYFUNCTION::JUMP     ,"key_Player1_jump",      "p1 Jump");
	bindings->addbinding(SDLK_LALT,  KEYFUNCTION::PLAYER1 | KEYFUNCTION::DIG      ,"key_Player1_dig",       "p1 Dig");
	bindings->addbinding(SDLK_z,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::HOOK_FIRE,"key_Player1_hook_fire", "p1 Fire hook");
	bindings->addbinding(SDLK_x,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::HOOK_RELEASE,"key_Player1_hook_release", "p1 Release hook");
	bindings->addbinding(SDLK_a,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::HOOK_IN,  "key_Player1_hook_in",   "p1 reel out hook");
	bindings->addbinding(SDLK_s,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::HOOK_OUT, "key_Player1_hook_out",  "p1 reel in hook");
	bindings->addbinding(SDLK_1,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::WEAPON1,  "key_Player1_weapon1",   "p1 weapon 1");
	bindings->addbinding(SDLK_2,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::WEAPON2,  "key_Player1_weapon2",   "p1 weapon 2");
	bindings->addbinding(SDLK_3,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::WEAPON3,  "key_Player1_weapon3",   "p1 weapon 3");
	bindings->addbinding(SDLK_4,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::WEAPON4,  "key_Player1_weapon4",   "p1 weapon 4");
	bindings->addbinding(SDLK_5,     KEYFUNCTION::PLAYER1 | KEYFUNCTION::WEAPON5,  "key_Player1_weapon5",   "p1 weapon 5");

	//player 2 keys: these defaults are completely useless
	bindings->addbinding(SDLK_KP0, KEYFUNCTION::PLAYER2 | KEYFUNCTION::UP       ,"key_Player2_up",        "p2 Up");
	bindings->addbinding(SDLK_KP1, KEYFUNCTION::PLAYER2 | KEYFUNCTION::DOWN     ,"key_Player2_down",      "p2 Down");
	bindings->addbinding(SDLK_KP2, KEYFUNCTION::PLAYER2 | KEYFUNCTION::LEFT     ,"key_Player2_left",      "p2 Left");
	bindings->addbinding(SDLK_KP3, KEYFUNCTION::PLAYER2 | KEYFUNCTION::RIGHT    ,"key_Player2_right",     "p2 Right");
	bindings->addbinding(SDLK_KP4, KEYFUNCTION::PLAYER2 | KEYFUNCTION::FIRE     ,"key_Player2_fire",      "p2 Fire");
	bindings->addbinding(SDLK_KP5, KEYFUNCTION::PLAYER2 | KEYFUNCTION::JUMP     ,"key_Player2_jump",      "p2 Jump");
	bindings->addbinding(SDLK_KP6, KEYFUNCTION::PLAYER2 | KEYFUNCTION::DIG      ,"key_Player2_dig",       "p2 Dig");
	bindings->addbinding(SDLK_KP7, KEYFUNCTION::PLAYER2 | KEYFUNCTION::HOOK_FIRE,"key_Player2_hook_fire", "p2 Fire hook");
	bindings->addbinding(SDLK_KP8, KEYFUNCTION::PLAYER2 | KEYFUNCTION::HOOK_RELEASE,"key_Player2_hook_release", "p2 Release hook");
	bindings->addbinding(SDLK_HOME,KEYFUNCTION::PLAYER2 | KEYFUNCTION::HOOK_IN,  "key_Player2_hook_in",   "p2 reel out hook");
	bindings->addbinding(SDLK_END, KEYFUNCTION::PLAYER2 | KEYFUNCTION::HOOK_OUT, "key_Player2_hook_out",  "p2 reel in hook");
	bindings->addbinding(SDLK_KP_DIVIDE,   KEYFUNCTION::PLAYER2 | KEYFUNCTION::WEAPON1,  "key_Player2_weapon1",   "p2 weapon 1");
	bindings->addbinding(SDLK_KP_MULTIPLY, KEYFUNCTION::PLAYER2 | KEYFUNCTION::WEAPON2,  "key_Player2_weapon2",   "p2 weapon 2");
	bindings->addbinding(SDLK_KP_MINUS,    KEYFUNCTION::PLAYER2 | KEYFUNCTION::WEAPON3,  "key_Player2_weapon3",   "p2 weapon 3");
	bindings->addbinding(SDLK_KP_PLUS,     KEYFUNCTION::PLAYER2 | KEYFUNCTION::WEAPON4,  "key_Player2_weapon4",   "p2 weapon 4");
	bindings->addbinding(SDLK_KP_EQUALS,   KEYFUNCTION::PLAYER2 | KEYFUNCTION::WEAPON5,  "key_Player2_weapon5",   "p2 weapon 5");
}

//----------------------------------------------------------------------------
Keymapper::~Keymapper()
{
	delete bindings;
}

//----------------------------------------------------------------------------
bool Keymapper::lookup(Nil_keyevent &keyevent)
{
	if (!keyevent.sdl_keyevent) {
    keyevent.keyfunction = KEYFUNCTION::NONE;
		return false;
	}

	Keymapper_bindings::iterator i = bindings->find_by_sdlsym(keyevent.sdl_keyevent->keysym.sym);
	if (i == bindings->end()) {
    keyevent.keyfunction = KEYFUNCTION::NONE;
		return false;
	}

	keyevent.keyfunction = (*i)->keyfunction;
	return true;
}

//----------------------------------------------------------------------------
void Keymapper::init(Configuration *config_)
{
	config_attach(config_);
}

//-----------------------------------------------------------------------
void Keymapper::config_changed()
{
	Keymapper_bindings::iterator i = bindings->begin();
	while (i != bindings->end()) {
		int intkey = configuration->get_option_int((char *)(*i)->config_name.c_str());
		if (intkey >= 0) {
    	(*i)->sdlsym = (SDLKey)intkey;
		}
		i++;
	}
}

//-----------------------------------------------------------------------
void Keymapper::bindkey(KEYFUNCTION::Function function, SDLKey sdlsym)
{
	//see if this key is alreay in use somewhere:
	Keymapper_bindings::iterator i = bindings->find_by_sdlsym(sdlsym);
	if (i != bindings->end()) {

		//get the currently bound key for this function:
		Keymapper_bindings::iterator j = bindings->find_by_function(function);
		if (j == bindings->end()) return;
		
		//bind the holder of the new key to the old key of the function to update
		char i_str[20];
    sprintf(i_str,"%i",(int)(*j)->sdlsym);

		//bind the specified function to the
		char j_str[20];
		sprintf(j_str,"%i",(int)sdlsym);
		
		configuration->set_option((char *)(*j)->config_name.c_str(),j_str);
		configuration->set_option((char *)(*i)->config_name.c_str(),i_str);
	} else {
		Keymapper_bindings::iterator j = bindings->find_by_function(function);
		char j_str[20];
		sprintf(j_str,"%i",(int)sdlsym);
		configuration->set_option((char *)(*j)->config_name.c_str(),j_str);
	}
}

