/***************************************************************************
                          keymapper.h  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk

 ***************************************************************************/

#ifndef KEYMAPPER_H
#define KEYMAPPER_H

#include "configuration.h"
#include <SDL/SDL.h>

namespace KEYFUNCTION {
	typedef enum Function {
		TARGET_MASK		= 0xff00,
		HOTKEY   			= 0x0000,
		PLAYER1 			= 0x0100,
		PLAYER2 			= 0x0200,

		FUNCTION_MASK = 0x00ff,
    NONE 					= 0x0000,

		//player controls:
		UP,
		DOWN,
		LEFT,
		RIGHT,
		FIRE,
		JUMP,
		DIG,
		HOOK_FIRE,
		HOOK_RELEASE,
		HOOK_IN,
		HOOK_OUT,
		WEAPON1,
		WEAPON2,
		WEAPON3,
		WEAPON4,
		WEAPON5,

		//other hotkeys:
		SCREEN_SHOOT,
		TOGGLE_LOGO,
		TOGGLE_DEATHCAM,
		TOGGLE_TRAFFIC,
		TOGGLE_FRAMERATE,
		TOGGLE_SHADOW,
		TOGGLE_SMOOTH,

		MENU
	};
};

typedef struct Nil_keyevent {
	SDL_KeyboardEvent *sdl_keyevent;
	KEYFUNCTION::Function keyfunction;
};

class Keymapper_bindings;
class Keymapper : protected Configuration_observer {
public: 
	Keymapper();
	virtual ~Keymapper();
	
	bool lookup(Nil_keyevent &keyevent);
	void init(Configuration *config_);

	Keymapper_bindings *get_bindings() {return bindings;}

	virtual void config_changed();

	void bindkey(KEYFUNCTION::Function function, SDLKey sdlsym);

protected:
	void addplayerkeys(KEYFUNCTION::Function player);
	Keymapper_bindings *bindings;		
};

#endif
