/***************************************************************************
                          obj_clusterbomb.cpp  -  description
                             -------------------
    begin                : Tue Feb 15 2000
    copyright            : (C) 2000 by Anders Rosendal
    email                : qute@klog.dk
 ***************************************************************************/


#include "obj_clusterbomb.h"
#include "all.h"

Obj_clusterbomb::Obj_clusterbomb(World *world_, int id) :Obj_base(world_,id)
{
	for(int i=0; i<4; i++)
		sprite[i] = 0;
	last_frame_shift=0;
	frame=0;
}

Obj_clusterbomb::~Obj_clusterbomb()
{
}

void Obj_clusterbomb::init(int owner, float xpos_, float ypos_, float xspeed_, float yspeed_, int count_, float damage_, float speed_)
{
	xpos=xpos_;
	ypos=ypos_;
	xspeed=xspeed_;
	yspeed=yspeed_;
	ownerid=owner;
	createtime=world->gettime();
	count=count_;
	damage=damage_;
	speed=speed_;
	timer=3;
	frame=0;
}

void Obj_clusterbomb::draw(Viewport *viewport)
{
	int x = ROUND(xpos)-viewport->xpos;
	int y = ROUND(ypos)-viewport->ypos;
 	viewport->draw_pixel_opaque(x,y,PIXEL(255,255,255) | PF_TYPE_EARTH);
    return;
 	 	
	if(age()>last_frame_shift+0.5) {
		last_frame_shift=age();
		frame=(frame+1)%4;
		
	}
	
	
	if (!sprite[frame]) {
		char s[100]; //STATIC_STRING
		sprintf(s,"obj/clusterbomb/clusterbomb%i.rgbf",frame);
		sprite[frame] = world->loader->graphics.getgraphic(s);
		if (!sprite[frame]) {
			logmsg(lt_warning,"couldn't load %s",s);
			return;
		}
	}
	
	sprite[frame]->draw_view(viewport,x,y);
}

void Obj_clusterbomb::serialize(Serializer *serializer)
{
    Obj_base::serialize(serializer);
	serializer->rw(last_frame_shift);
	serializer->rw(frame);
	serializer->rw(timer);
	serializer->rw(count);
	serializer->rw(damage);
	serializer->rw(speed);
}

void Obj_clusterbomb::server_think()
{
	Serverworld *serverworld = (Serverworld *)world;
	
	Map_hit hit = update_simple(true); //this calls client_think() for us and checks for collisions
	
	if (hit.hittype != ht_none) {
		net_dirty = true;
		bogo_bounce();
	}
	
	if(age()>timer) {
		done=true;
		float x,y;
	    getpos(x,y);
	
		for(float angle =0; angle<2*PI; angle+=2*PI/(count+1)) {
			float bullet_angle = angle;
			Vector bullet_vector = rad2vector(bullet_angle);
			bullet_vector.scale(speed);
			
			Obj_grenade *grenade = (Obj_grenade *)serverworld->newobject(ot_grenade);
			if (grenade) {
				grenade->init(
					ownerid,
					x,y,
					xspeed+bullet_vector.x,
					yspeed+bullet_vector.y,
					damage,
					12,
					2.2+rnd(-200,200)/1000.0
				);
			}
		}
		Obj_explosion *explosion = (Obj_explosion *)serverworld->newobject(ot_explosion);
		if (explosion) {
			explosion->init(
				ownerid,
				xpos,
				ypos,
				8,
				75
			);
		}/**/
	}
	
}
