/***************************************************************************
                          obj_player.h  -  description
                             -------------------
    begin                : Sat Oct 30 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef OBJ_PLAYER_H
#define OBJ_PLAYER_H

#include "obj_base.h"
#include "controls.h"

class Obj_player_data;
class Obj_player_avatar : public Obj_base  {
public:
	
	Obj_player_avatar(World *world_, int id);
	virtual ~Obj_player_avatar();

	void init(int owner, int x, int y);

	virtual Object_type gettype() {return ot_player_avatar;}
 	virtual void server_think();
	virtual void draw(Viewport *viewport);
	virtual void serialize(Serializer *serializer);
	virtual void client_think();
	virtual bool hurtable() {return true;}
	virtual void hurt(float hitpoints, Vector speed, int hurter);
	virtual bool is_passable(int offset);

	typedef enum State {
		PRESPAWNING,
  	SPAWNING,
		LIVING,
		DIEING
	};
	State getstate() {return (State)state;}

	float gethealth() {return health;}

protected:

	//hook action:
	void hook_fire();
	void hook_release();
	void hook_in();
	void hook_out();

	void setup_constants();
	float elevation;
	int direction;	
	Controls *controls;
	Obj_player_data *player_data;


  int hook_id;
	int hurter_id;
	
	int state;
//	Graphic *sprite[3][17];

	char animation_sequence;

	int cur_walk_frame;	
	int dig_now;
	float health;
	float damage; //hitpoints accumulated in this frame
	Vector damage_speed;
	float vaporize;
};

#endif
