/***************************************************************************
                          obj_projectile.cpp  -  description
                             -------------------
    begin                : Sun Dec 19 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "obj_projectile.h"
#include "all.h"

//------------------------------------------------------------------
Obj_projectile::Obj_projectile(World *world_, int id) : Obj_base(world_,id)
{
}

//------------------------------------------------------------------
Obj_projectile::~Obj_projectile()
{
}

//------------------------------------------------------------------
void Obj_projectile::init(int owner, float xpos_, float ypos_, float xspeed_, float yspeed_, float explosion_damage_, int explosion_size_, int penetration_, float init_age)
{
	ownerid = owner;
	xpos = xpos_;
	ypos = ypos_;
	xspeed = xspeed_;
	yspeed = yspeed_;
	explosion_damage = explosion_damage_;
	explosion_size = explosion_size_;
	penetration = penetration_;
	air_resistance = 0;
	yaccel = DEFAULT_ACCEL/5;
	curtime = world->gettime()-init_age;
}

//------------------------------------------------------------------
void Obj_projectile::draw(Viewport *viewport)
{
	int x = ROUND(xpos)-viewport->xpos;
	int y = ROUND(ypos)-viewport->ypos;
 	viewport->draw_pixel_opaque(x,y,PIXEL(255,255,255) | PF_TYPE_EARTH);

/*obsolete	
	if (x >= 0 && y >= 0 && x < viewport->get_xsize() && y < viewport->get_ysize()) {
    int32 *target = viewport->get_pixels()+x+y*viewport->get_xsize();
		*target = 0xffffff | PF_TYPE_EARTH;
	}
*/
}

//------------------------------------------------------------------
void Obj_projectile::serialize(Serializer *serializer)
{
	Obj_base::serialize(serializer);
//	thinker->RWfloat(explosion_damage);
//	thinker->RWint(explosion_size);
}

//------------------------------------------------------------------
void Obj_projectile::server_think()
{
  Serverworld *serverworld = (Serverworld *)world;
	Map_hit hit = update_simple(true); //this calls client_think() for us and checks for collisions

	if (hit.hittype != ht_none) {
		
		//do the explosion
		{
			Vector speed;
			speed.x = old_xspeed;
			speed.y = old_yspeed;
			speed.normalize();
			speed.scale(penetration);

			Obj_explosion *explosion = (Obj_explosion *)serverworld->newobject(ot_explosion);
			if (explosion) {
				explosion->init(
					ownerid,
					hit.xc+speed.x+1,
					hit.yc+speed.y,
					explosion_size,
					explosion_damage
				);
			}
		}

		if (hit.hittype == ht_object) {
			Vector speed;
			speed.x = old_xspeed;
			speed.y = old_yspeed;

    	Obj_base *victim = world->get_object(hit.objectid,ot_error);
			if (victim) {
      	victim->hurt(explosion_damage,speed,ownerid);
			}
		}
/*
		penetration--;
		if (penetration < 0)*/
			done=true;
	}
}






















