/***************************************************************************
                          obj_weapon_flamethrower.cpp  -  description
                             -------------------
    begin                : Mon Dec 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "obj_weapon_flamethrower.h"
#include "obj_fireball.h"
#include "all.h"

Obj_weapon_flamethrower::Obj_weapon_flamethrower(World *world_, int id) :Obj_weapon(world_,id)
{
	reload_speed = 1;
	shot_cost = 0.01;
	reshoot_time = 0.075;
	knock_back = 3.0;
}

Obj_weapon_flamethrower::~Obj_weapon_flamethrower()
{
}

const int BULLET_SPEED = 80;
const int BULLET_SPEED_SPREAD = 10;
const int SUBSHOTS = 4;

void Obj_weapon_flamethrower::dofire(int x, int y, Vector aim_vector, float aim_angle)
{
	Serverworld *serverworld = (Serverworld *)world;
	float frame_delta = world->get_last_frame_delta();

	Vector bullet_vector = rad2vector(aim_angle);
	bullet_vector.scale(BULLET_SPEED);

	knock_back_direction.add(bullet_vector);

	Obj_fireball *bullet = (Obj_fireball *)serverworld->newobject(ot_fireball);
	if (bullet) {
		bullet->init(
			ownerid,
			x,y,
			xspeed+bullet_vector.x,
			yspeed+bullet_vector.y,
			6,
			7,
			2,
			1
		);
		//Say <bang!> here..
	}
}

















