/***************************************************************************
                          obj_weapon_minigun.cpp  -  description
                             -------------------
    begin                : Mon Dec 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "obj_weapon_minigun.h"
#include "all.h"

Obj_weapon_minigun::Obj_weapon_minigun(World *world_, int id) :Obj_weapon(world_,id)
{
	reload_speed = 0.2;
	shot_cost = 0.05;
	reshoot_time = 0.0;
	knock_back = 10.0;
}

Obj_weapon_minigun::~Obj_weapon_minigun()
{
}

const int BULLET_SPEED = 200;
const int BULLET_SPEED_SPREAD = 10;
const int BULLET_ANGLE_SPREAD = 40;
const int SUBSHOTS = 4;

void Obj_weapon_minigun::dofire(int x, int y, Vector aim_vector, float aim_angle)
{
	Serverworld *serverworld = (Serverworld *)world;
	float frame_delta = world->get_last_frame_delta();

	for (int c=0;c<SUBSHOTS;c++) {

		float bullet_angle = aim_angle+rnd(-BULLET_ANGLE_SPREAD,BULLET_ANGLE_SPREAD)/1000.0;
		Vector bullet_vector = rad2vector(bullet_angle);
		bullet_vector.scale(rnd((1000-BULLET_SPEED_SPREAD/3)*BULLET_SPEED,(1000+BULLET_SPEED_SPREAD)*BULLET_SPEED)/1000.0);

		knock_back_direction.add(bullet_vector);
		
	 	Obj_projectile *bullet = (Obj_projectile *)serverworld->newobject(ot_projectile);
		if (bullet) {
			bullet->init(
				ownerid,
				x,y,
				xspeed+bullet_vector.x,
				yspeed+bullet_vector.y,
				20,
				7,
				2,
				frame_delta*c/(SUBSHOTS*1.0)
			);
			//Say <bang!> here..
		}
	}
}

















