/***************************************************************************
                          obj_weapon_rocket.cpp  -  description
                             -------------------
    begin                : Fri Feb 25 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#include "obj_weapon_rocket.h"
#include "all.h"

Obj_weapon_rocket::Obj_weapon_rocket(World *world_, int id) :Obj_weapon(world_,id)
{
       reload_speed = 0.4;
       shot_cost = 0.2;
       reshoot_time = 0.45;
       knock_back = 2.0;
}

Obj_weapon_rocket::~Obj_weapon_rocket()
{
}

void Obj_weapon_rocket::dofire(int x, int y, Vector aim_vector, float aim_angle)
{
       Serverworld *serverworld = (Serverworld *)world;
       aim_vector.scale(1500);

       knock_back_direction.add(aim_vector);

       Obj_rocket *rocket = (Obj_rocket *)serverworld->newobject(ot_rocket);
       if (rocket) {
               rocket->init(
                       ownerid,
                       x,y,
                       xspeed+aim_vector.x,
                       yspeed+aim_vector.y,
                       0.0,
                       750,
                       16
               );
       }
}

