/***************************************************************************
                          obj_weapon_shotgun.cpp  -  description
                             -------------------
    begin                : Thu Dec 23 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "obj_weapon_shotgun.h"
#include "all.h"

Obj_weapon_shotgun::Obj_weapon_shotgun(World *world_, int id) :Obj_weapon(world_,id)
{
	reload_speed = 0.2;
	shot_cost = 0.5;
	reshoot_time = 1.0;
	knock_back = 100.0;
}

Obj_weapon_shotgun::~Obj_weapon_shotgun()
{
}

const int BULLET_SPEED = 300;
const int BULLET_SPEED_SPREAD = 200;
const int BULLET_ANGLE_SPREAD = 150;
const int SUBSHOTS = 40;

void Obj_weapon_shotgun::dofire(int x, int y, Vector aim_vector, float aim_angle)
{
	Serverworld *serverworld = (Serverworld *)world;

	for (int c=0;c<SUBSHOTS;c++) {

		float bullet_angle = aim_angle+rnd(-BULLET_ANGLE_SPREAD,BULLET_ANGLE_SPREAD)/1000.0;
		Vector bullet_vector = rad2vector(bullet_angle);
		bullet_vector.scale(rnd((1000-BULLET_SPEED_SPREAD/3)*BULLET_SPEED,(1000+BULLET_SPEED_SPREAD)*BULLET_SPEED)/1000.0);

		knock_back_direction.add(bullet_vector);
		
	 	Obj_projectile *bullet = (Obj_projectile *)serverworld->newobject(ot_projectile);
		if (bullet) {
			bullet->init(
				ownerid,
				x,y,
				xspeed+bullet_vector.x,
				yspeed+bullet_vector.y,
				20,
				8,
				1,
				0
			);
			//Say <bang!> here..
		}
	}
}
