/***************************************************************************
                          serializer_reader.cpp  -  description
                             -------------------
    begin                : Sat Jan 15 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "serializer_reader.h"
#include "systemheaders.h"

//-------------------------------------------------------------------
Serializer_reader::Serializer_reader()
{
	buffer_size = 1000;
	buffer = (char *)malloc(buffer_size);
	clear();
}

//-------------------------------------------------------------------
Serializer_reader::~Serializer_reader()
{
	free(buffer);
}

//-------------------------------------------------------------------
char *Serializer_reader::getbuffer()
{
	return buffer;
}

//-------------------------------------------------------------------
void Serializer_reader::add_bytes(char *data, int length)
{
 	if (length + buffer_inuse > buffer_size) {
		buffer_size *= 2;
		while (length + buffer_inuse > buffer_size)	buffer_size *= 2;
		buffer = (char *)realloc(buffer,buffer_size);
	}	
	memcpy(&buffer[buffer_inuse],data,length);
	buffer_inuse += length;
}

//-------------------------------------------------------------------
void Serializer_reader::rw(char &value)
{
	add_bytes((char *)&value,sizeof(value));
}

//-------------------------------------------------------------------
void Serializer_reader::rw(int &value)
{
	add_bytes((char *)&value,sizeof(value));
}

//-------------------------------------------------------------------
void Serializer_reader::rw(int32 &value)
{
	add_bytes((char *)&value,sizeof(value));
}

//-------------------------------------------------------------------
void Serializer_reader::rw(bool &value)
{
	add_bytes((char *)&value,sizeof(value));
}

//-------------------------------------------------------------------
void Serializer_reader::rw(float &value)
{
	add_bytes((char *)&value,sizeof(value));
}

//-------------------------------------------------------------------
void Serializer_reader::rw(double &value)
{
	add_bytes((char *)&value,sizeof(value));
}

//-------------------------------------------------------------------
void Serializer_reader::rwstr(char *value, int maxsize)
{
	int len = strlen(value);
	wint(len);
	add_bytes(value,len);
}

//-------------------------------------------------------------------
void Serializer_reader::rwblob(char *blob, int size)
{
	add_bytes(blob,size);
}
