/***************************************************************************
                          serializer_reader.h  -  description
                             -------------------
    begin                : Sat Jan 15 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef SERIALIZER_READER_H
#define SERIALIZER_READER_H

#include "serializer.h"

/**
  *@author Flemming Frandsen
  */

class Serializer_reader : public Serializer  {
public: 
	Serializer_reader();
	virtual ~Serializer_reader();
          	
	void clear() {buffer_inuse = 0;}

	virtual bool isreading() {return true;}

//The simple datatypes:
	virtual void rw(char &value);
	virtual void rw(int &value);
	virtual void rw(int32 &value);
	virtual void rw(bool &value);
	virtual void rw(float &value);
	virtual void rw(double &value);
//The complex ones
	virtual void rwstr(char *value, int maxsize);
	virtual void rwblob(char *blob, int size);

//This is just syntactical sugar to avoid declaring an int variable for writing
	void wint(int value) 	   { rw(value); }
	void wfloat(float value) { rw(value); }

	//getting thoughts out in one lump when done collecting them.
	char *getbuffer();

	virtual int get_pos() {return buffer_inuse;}
	protected:
	inline void add_bytes(char *data, int length);
};

#endif
