/***************************************************************************
                          serializer_writer.h  -  description
                             -------------------
    begin                : Sat Jan 15 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef SERIALIZER_WRITER_H
#define SERIALIZER_WRITER_H

#include "serializer.h"
#include "nil_math.h"
#include "fluff.h"

/**
  *@author Flemming Frandsen
  */

class Serializer_writer : public Serializer  {
public: 
	Serializer_writer();
	~Serializer_writer();

	virtual bool isreading() {return false;}

	char *setbuffer(int newlength);

//Used for looking ahead when interpreting a stream
  int next_int();
	bool eat_int(int expected);

//The simple datatypes:
	virtual void rw(char &value);
	virtual void rw(int &value);
	virtual void rw(int32 &value);
	virtual void rw(bool &value);
	virtual void rw(float &value);
	virtual void rw(double &value);
//complex datatypes:
	virtual void rwstr(char *value, int maxsize);
	virtual void rwblob(char *blob, int size);

//syntactical sugar:
	int rint() 			{int i; rw(i); return i;}	
	float rfloat()	{float i; rw(i); return i;}	

//plumbing
	void rewind() {empty_read_error = false; curmsg = 0;} //resets the pointer, rarely used (if ever)
	bool empty() { return curmsg >= buffer_inuse;}
	bool empty_read() {return empty_read_error;}

	virtual int get_pos() {return curmsg;}
	protected:
	inline bool get_bytes(char *data, int length);

	bool empty_read_error;
	int curmsg; //offset to begining of current thought.
};

#endif
