/***************************************************************************
                          serverworld.h  -  description
                             -------------------
    begin                : Wed Oct 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef SERVERWORLD_H
#define SERVERWORLD_H

//class World;

#include "world.h"
#include "systemheaders.h"
#include "netpackets.h"
#include "serializer_reader.h"
#include "update_queue.h"

class Obj_player_data;

class Serverworld : public World  {
public: 
	Serverworld(Loader *loader_, Soundsystem *soundsystem_);
	virtual ~Serverworld();

	/*
	 * Called by the server to do all the thinking that needs to be done
	 * This will clear and then set the thoughts that need to be sent to the clients..
	 */
	void server_think(Update_queue *update_queue);

	virtual bool isclient() {return false;}

	Obj_base *newobject(Object_type objecttype);

	virtual void makehole(int x, int y, int diameter);

	void make_all_dirty();

	bool handle_join_request(
			Net_joinrequest &joinrequest,					//input, comes from the client

			Obj_player_data *&new_player,  	//output, don't delete!
			Net_joinreply &joinreply,				//output
			char *&map_data                 //output, free() when done
		);
		
	void save_original_map();
	int last_reader_length;
	
	void do_radius_damage(int hurter_id, float xpos, float ypos, float radius, float damage);
	bool hit_object(float old_xpos, float old_ypos, float xpos, float ypos, int &cx, int &cy, int &id);

protected:
	int killer_line;
	void cleanup();
	int32 *original_map;
	int next_free_objectid;
	
	void kill_lonely_bits(Serializer_reader *serializer_reader);
};

#endif
