/***************************************************************************
                          tcp_client.cpp  -  description
                             -------------------
    begin                : Wed Nov 17 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "systemheaders.h"
#include "tcp_client.h"
#include "fluff.h"
#include "stdio.h"


//-------------------------------------------------------------------------
Tcp_client::~Tcp_client()
{
	shutdown(socket,2);
}

//-------------------------------------------------------------------------
int Tcp_client::connect(const char *server, unsigned short port)
{
	//create the socket
	socket = ::socket(AF_INET, SOCK_STREAM, getprotobyname("tcp")->p_proto);
	if (socket <= 0) {
  	return -1;
	}

  struct hostent *server_hostent = gethostbyname(server);
	if (!server_hostent) {
		logmsg(lt_error,"Unable to find server '%s'",server);
  	return -2;
	}
/*
	{
		unsigned int is = *(unsigned int *)server_hostent->h_addr_list[0];
		logmsg(lt_debug,"Found server '%s' at %i.%i.%i.%i",
			server,
			 is        & 0xff,
			(is >>  8) & 0xff,
			(is >> 16) & 0xff,
			(is >> 24) & 0xff
		);
  }
*/
 	sockaddr_in serveraddr;
	serveraddr.sin_family = AF_INET;
  serveraddr.sin_port 	= htons(port);
  serveraddr.sin_addr.s_addr = *(unsigned int *)server_hostent->h_addr_list[0];
	int connect_error = ::connect(socket, (sockaddr *) &serveraddr, sizeof(serveraddr));
	if (connect_error) {
  	return -3;
	}

	return 0;
}
