/***************************************************************************
                          tcp_server_connection.h  -  description
                             -------------------
    begin                : Sat Nov 13 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

/**
  *@author Flemming Frandsen
  */

#ifndef TCP_SERVER_CONNECTION_H
#define TCP_SERVER_CONNECTION_H

#include "fluff.h"
#include "all.h"
#include "systemheaders.h"
#include "tcp_socket.h"

class Tcp_server;
class Tcp_server_connection : public Tcp_socket {
public:
	Tcp_server_connection();
	~Tcp_server_connection();

	void poll(); //used by the thread and it should be polled if we are running in single threaded mode

	int accept(Tcp_server *tcp_server_, int server_socket);

	friend void *start_server_connection(void *arg);

	void terminate() {bedone = true;}
	bool isdone() {return done;}

	//The update that this client is currently working with
	int get_current_update_id() {return current_update_id;}
	int get_ack_update_id() {return ack_update_id;}

	//this is here to be preserved through several calls to poll()
	Obj_player_data *player;
protected:
	int ack_update_id;
	int current_update_id;
	bool joinclient();

	bool done;
	void execute();
	Tcp_server *tcp_server;
	pthread_t threaddata;
	sockaddr_in client_addr;
};

#endif