/***************************************************************************
                          tcp_socket.h  -  description
                             -------------------
    begin                : Mon Jan 17 2000
    copyright            : (C) 2000 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/
/**
  *@author Flemming Frandsen
  */

#ifndef TCP_SOCKET_H
#define TCP_SOCKET_H

#include "serializable.h"
#include "serializer_reader.h"
#include "serializer_writer.h"

#define IP_TIMEOUT 5000


class Tcp_socket {
protected:
	int socket;		//set this to the socket you connected.
	bool bedone; 	//this is set to true if something fails

public:

	//read and write a Serializer
	int send(Serializer_reader *serializer_reader);
	int recv(Serializer_writer *serializer_writer, int max_sane_size=0xffff);

	//read and write a Serializable object
	int send(Serializable *object);
	int recv(Serializable *object);

	//read and write a single int
	int send(int value);
	int recv(int &value);

	//read and write a raw buffer
	int send(void *buf, int len, unsigned int timeout = IP_TIMEOUT);
	int recv(void *buf, int len, unsigned int timeout = IP_TIMEOUT);

private:
	//These are members because they are expensive to construct
	Serializer_writer writer;
	Serializer_reader reader;
};

#endif
