/***************************************************************************
                          thinker.h  -  description
                             -------------------
    begin                : Wed Oct 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/

#ifndef THINKER_H
#define THINKER_H
#include "systemheaders.h"

//Thought types:
typedef enum Thought_type {
	tt_object_state, 		//The package is the state of an object, object_type, object_id, object data
	tt_object_delete,		//delete an object
	tt_world_state,			//The world state follows.
	tt_map_random,			//A new new map created from a randomseed

	tt_error         		//used when a function returns error
};

/**Class that 
  *@author Flemming Frandsen
	* This class will read or write a bunch of datatypes
  */

class Thinker {
public: 
	Thinker();

	virtual bool iscollecting()=0;

//The simple datatypes:
	virtual void RWchar(char &value)=0;
	virtual void RWint(int &value)=0;
	virtual void RWint(int32 &value)=0;
	virtual void RWbool(bool &value)=0;
	virtual void RWfloat(float &value)=0;
	virtual void RWdouble(double &value)=0;
	virtual void RWstr(char *value)=0;
	virtual void RWfixed(char *blob, int size)=0;

//The complex ones (some would say ugly)
	virtual bool RWblob(void *blob, int &size)=0;

/*
	When reading:
		returns true if everything is fine and the blob was read (The number of bytes size will be in size)
	  if the buffer was too small then it returns false and sets size to the number of bytes that the buffer must be
	
	When writing it always works (returns true)

	This should work regardless:
	while (!thinker.RWblob((void *)myblob,sizeofblob)
		myblob = realloc(sizeofblob);

	Use this if you want to be sure to get all of a string
*/


};

#endif






















