/***************************************************************************
                          thought_collector.h  -  description
                             -------------------
    begin                : Wed Oct 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef THOUGHT_COLLECTOR_H
#define THOUGHT_COLLECTOR_H

#include "thinker.h"

/**
  *@author Flemming Frandsen
  */

class Thought_collector : public Thinker  {
public: 
	Thought_collector();
	virtual ~Thought_collector();
	
	void clear() {buffer_inuse = 0;}

	virtual bool iscollecting() {return true;};

//call this before putting a thought to the collector
	void start_thought(Thought_type type) { add_bytes((char *)&type,sizeof(Thought_type));}

//This is just syntactical sugar to avoid declaring an int variable for writing
//these are created ad hoc, so don't hold back if there is somthing you need.
	void Wint(int value) 			{ RWint(value); }
	void Wfloat(float value) 	{ RWfloat(value); }

//The simple datatypes:
	virtual void RWchar(char &value) 		{ add_bytes((char *)&value,sizeof(value));}
	virtual void RWint(int &value) 			{ add_bytes((char *)&value,sizeof(value));}
	virtual void RWint(int32 &value) 			{ add_bytes((char *)&value,sizeof(value));}
	virtual void RWbool(bool &value)		{ add_bytes((char *)&value,sizeof(value));}
	virtual void RWfloat(float &value)	{ add_bytes((char *)&value,sizeof(value));}
	virtual void RWdouble(double &value){	add_bytes((char *)&value,sizeof(value));}
	virtual void RWstr(char *value)			{ Wint(strlen(value)); add_bytes(value,strlen(value));}
	virtual void RWfixed(char *blob, int size) {add_bytes(blob,size);}

//The complex one (some would say ugly)
	virtual bool RWblob(void *blob, int &size);

	//getting thoughts out in one lump when done collecting them.
	int getlength();
	char *getbuffer();

	protected:
	inline void add_bytes(char *data, int length);

	char *buffer;
	int buffer_size;
  int buffer_inuse;	
};

#endif



































