/***************************************************************************
                          thought_spreader.cpp  -  description
                             -------------------
    begin                : Wed Oct 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#include "thought_spreader.h"
#include "fluff.h"
#include "systemheaders.h"

Thought_spreader::Thought_spreader()
{
	buffer_size = 1000;
	buffer_inuse = 0;
	buffer = (char *)malloc(buffer_size);
}

//-----------------------------------------------------------
Thought_spreader::~Thought_spreader()
{
	free(buffer);
}

//-----------------------------------------------------------
char *Thought_spreader::setbuffer(int newlength)
{
	if (newlength > buffer_size) {
		buffer_size=newlength;
  	buffer = 	(char *)realloc(buffer,buffer_size);
	}
	
	buffer_inuse = newlength;

	rewind();

	return buffer;
}

//-----------------------------------------------------------
Thought_type Thought_spreader::next_type()
{
	if (empty() || curmsg+(signed)sizeof(Thought_type) > buffer_size)
		return tt_error;
	else
		return *((Thought_type*)(&buffer[curmsg]));
}

//-----------------------------------------------------------
bool Thought_spreader::eat_type(Thought_type expected_type)
{
	if (next_type() == expected_type) {
		curmsg+=sizeof(Thought_type);
		return true;  		
	} else {
		curmsg+=sizeof(Thought_type);
		return false;  		
	}
}

//-----------------------------------------------------------
bool Thought_spreader::RWblob(void *blob, int &size)
{
	int blobsize = *((int *)(&buffer[curmsg]));
	if (blobsize <= size) {
		size = blobsize;		
		curmsg += sizeof(int);
		get_bytes((char*)blob, size);  	
		return true;
	} else {
		size = blobsize;
  	return false;
	}
}

inline bool Thought_spreader::get_bytes(char *data, int length)
{
	if (curmsg+length > buffer_size) {
		logmsg(lt_warning, "tried to read %i bytes from the thought_spreader, that was too many",length,lt_error);
		return false;
	} else {
		memcpy(data, &buffer[curmsg],length);
		curmsg += length;
		return true;
	}
}



