/***************************************************************************
                          thought_spreader.h  -  description
                             -------------------
    begin                : Wed Oct 20 1999
    copyright            : (C) 1999 by Flemming Frandsen
    email                : dion@swamp.dk
 ***************************************************************************/


#ifndef THOUGHT_SPREADER_H
#define THOUGHT_SPREADER_H

#include "thinker.h"

/**
  *@author Flemming Frandsen
  */

class Thought_spreader : public Thinker  {
public: 
	Thought_spreader();
	virtual ~Thought_spreader();

	virtual bool iscollecting() {return false;}


	// adding them in one lump    like: memcpy(thoughts.setbuffer(size),buffer,size);
	char *setbuffer(int newlength);


  Thought_type next_type(); //the next thought type that is in the stream
	bool eat_type(Thought_type expected_type); //reads a thought type from the stream, returns false if it is the wrong type

//syntactical sugar:
	int Rint() 			{int i; RWint(i); return i;}	
	float Rfloat()	{float i; RWfloat(i); return i;}	

//The simple datatypes:
	virtual void RWchar(char &value)			{get_bytes((char *)&value,sizeof(value));}
	virtual void RWint(int &value)				{get_bytes((char *)&value,sizeof(value));}
	virtual void RWint(int32 &value)			{get_bytes((char *)&value,sizeof(value));}
	virtual void RWbool(bool &value)			{get_bytes((char *)&value,sizeof(value));}
	virtual void RWfloat(float &value)		{get_bytes((char *)&value,sizeof(value));}
	virtual void RWdouble(double &value)	{get_bytes((char *)&value,sizeof(value));}
	virtual void RWstr(char *value)				{int len=Rint(); get_bytes(value,len); value[len]=0;}
	virtual void RWfixed(char *blob, int size) {get_bytes(blob,size);}

//The complex one (some would say ugly)
	virtual bool RWblob(void *blob, int &size);

	void rewind() {curmsg = 0;} //resets the pointer, rarely used (if ever)
	bool empty() { return curmsg >= buffer_inuse;}

	protected:
	inline bool get_bytes(char *data, int length);

	char *buffer;
	int buffer_size;
  int buffer_inuse;	

	int curmsg; //offset to begining of current thought.
};

#endif






















