#ifndef WINRANDOM_H
#define WINRANDOM_H

#ifdef __cplusplus
extern "C" {
#endif

#define __set_errno(Val) errno = (Val)
typedef int int32_t;

struct random_data
  {
    int32_t *fptr;		/* Front pointer.  */
    int32_t *rptr;		/* Rear pointer.  */
    int32_t *state;		/* Array of state values.  */
    int rand_type;		/* Type of random number generator.  */
    int rand_deg;		/* Degree of random number generator.  */
    int rand_sep;		/* Distance between front and rear.  */
    int32_t *end_ptr;		/* Pointer behind state table.  */
  };

void srandom(unsigned int x);
void *initstate (unsigned int seed, void *arg_state, size_t n);
void *setstate (void* arg_state);
int32_t random ();

int srandom_r (unsigned int seed, struct random_data *buf);
int initstate_r (unsigned int seed, void *arg_state, size_t n, struct random_data *buf);
int setstate_r (void *arg_state, struct random_data *buf);
int random_r (struct random_data *buf, int32_t *result);

#ifdef __cplusplus
} // extern "C"
#endif

#endif