#ifndef WIN32_SYSTEM_H
#define WIN32_SYSTEM_H

#define NOMINMAX

#include <windows.h>
#include <io.h>
#include <SDL_main.h>
#include "random.h"

#ifdef min
#undef min
#endif
#ifdef max
#undef max
#endif

// Disable some annoying warnings
#pragma warning (disable : 4244)
#pragma warning (disable : 4305)
#pragma warning (disable : 4786)
#pragma warning (disable : 4800)
#pragma warning (disable : 4091)

// Used for stat
#define S_ISMT(x)  ((x) & S_IFMT )
#define S_ISDIR(x) ((x) & S_IFDIR)
#define S_ISCHR(x) ((x) & S_IFCHR)
#define S_ISREG(x) ((x) & S_IFREG)

// for nnil_map 
#define MAP_SHARED 0
#define MAP_FAILED (void*)-1
#define PROT_READ 0

char *strsep(char **stringp, const char *delim);
#define snprintf _snprintf

#ifndef INT32_DEFINED
#define INT32_DEFINED
typedef unsigned int int32;
#endif

#ifdef __cplusplus
inline int strcasecmp(const char* string1, const char* string2) 
{
		return _stricmp(string1,string2);
}
inline void sleep(unsigned long sec)		{ Sleep((sec)*1000); }
inline void usleep(unsigned long usec)	{ Sleep((usec)/1000);}
#endif

#ifdef __cplusplus
extern "C" 
#endif
	int SDL_main(int argc, char *argv[]);

int NiL_main(int argc, char *argv[]);
#ifdef main
#undef main
#endif
#define main NiL_main

#endif